base-4.8.1.0: Basic libraries

Safe Haskell | None
Language | Haskell2010

GHC.RTS.Flags

Description

Accessors to GHC RTS flags. Descriptions of flags can be seen in GHC User's Guide, or by running RTS help message using `+RTS --help`.

Since: 4.8.0.0

Synopsis

- data RTSFlags = RTSFlags {
  - gcFlags :: GCFlags
  - concurrentFlags :: ConcFlags
  - miscFlags :: MiscFlags
  - debugFlags :: DebugFlags
  - costCentreFlags :: CCFlags
  - profilingFlags :: ProfFlags
  - traceFlags :: TraceFlags
  - tickyFlags :: TickyFlags
  }
- data GCFlags = GCFlags {
  - statsFile :: Maybe FilePath
  - giveStats :: GiveGCStats
  - maxStkSize :: Nat
  - initialStkSize :: Nat
  - stkChunkSize :: Nat
  - stkChunkBufferSize :: Nat
  - maxHeapSize :: Nat
  - minAllocAreaSize :: Nat
  - minOldGenSize :: Nat
  - heapSizeSuggestion :: Nat
  - heapSizeSuggestionAuto :: Bool
  - oldGenFactor :: Double
  - pcFreeHeap :: Double
  - generations :: Nat
  - steps :: Nat
  - squeezeUpdFrames :: Bool
  - compact :: Bool
  - compactThreshold :: Double
  - sweep :: Bool
  - ringBell :: Bool
  - frontpanel :: Bool
  - idleGCDelayTime :: Time
  - doIdleGC :: Bool
  - heapBase :: Word
  - allocLimitGrace :: Word
  }
- data ConcFlags = ConcFlags {
  - ctxtSwitchTime :: Time
  - ctxtSwitchTicks :: Int
  }
- data MiscFlags = MiscFlags {
  - tickInterval :: Time
  - installSignalHandlers :: Bool
  - machineReadable :: Bool
  - linkerMemBase :: Word
  }
- data DebugFlags = DebugFlags {
  - scheduler :: Bool
  - interpreter :: Bool
  - weak :: Bool
  - gccafs :: Bool
  - gc :: Bool
  - block_alloc :: Bool
  - sanity :: Bool
  - stable :: Bool
  - prof :: Bool
  - linker :: Bool
  - apply :: Bool
  - stm :: Bool
  - squeeze :: Bool
  - hpc :: Bool
  - sparks :: Bool
  }
- data CCFlags = CCFlags {
  - doCostCentres :: DoCostCentres
  - profilerTicks :: Int
  - msecsPerTick :: Int
  }
- data ProfFlags = ProfFlags {
  - doHeapProfile :: DoHeapProfile
  - heapProfileInterval :: Time
  - heapProfileIntervalTicks :: Word
  - includeTSOs :: Bool
  - showCCSOnException :: Bool
  - maxRetainerSetSize :: Word
  - ccsLength :: Word
  - modSelector :: Maybe String
  - descrSelector :: Maybe String
  - typeSelector :: Maybe String
  - ccSelector :: Maybe String
  - ccsSelector :: Maybe String
  - retainerSelector :: Maybe String
  - bioSelector :: Maybe String
  }
- data TraceFlags = TraceFlags {
  - tracing :: DoTrace
  - timestamp :: Bool
  - traceScheduler :: Bool
  - traceGc :: Bool
  - sparksSampled :: Bool
  - sparksFull :: Bool
  - user :: Bool
  }
- data TickyFlags = TickyFlags {
  - showTickyStats :: Bool
  - tickyFile :: Maybe FilePath
  }
- getRTSFlags :: IO RTSFlags
- getGCFlags :: IO GCFlags
- getConcFlags :: IO ConcFlags
- getMiscFlags :: IO MiscFlags
- getDebugFlags :: IO DebugFlags
- getCCFlags :: IO CCFlags
- getProfFlags :: IO ProfFlags
- getTraceFlags :: IO TraceFlags
- getTickyFlags :: IO TickyFlags

# Documentation

data RTSFlags Source

Constructors

RTSFlags |
Fields gcFlags :: GCFlags concurrentFlags :: ConcFlags miscFlags :: MiscFlags debugFlags :: DebugFlags costCentreFlags :: CCFlags profilingFlags :: ProfFlags traceFlags :: TraceFlags tickyFlags :: TickyFlags

Instances

Show RTSFlags |

data GCFlags Source

Constructors

GCFlags |
Fields statsFile :: Maybe FilePath giveStats :: GiveGCStats maxStkSize :: Nat initialStkSize :: Nat stkChunkSize :: Nat stkChunkBufferSize :: Nat maxHeapSize :: Nat minAllocAreaSize :: Nat minOldGenSize :: Nat heapSizeSuggestion :: Nat heapSizeSuggestionAuto :: Bool oldGenFactor :: Double pcFreeHeap :: Double generations :: Nat steps :: Nat squeezeUpdFrames :: Bool compact :: Bool True = "compact all the time" compactThreshold :: Double sweep :: Bool use "mostly mark-sweep" instead of copying for the oldest generation ringBell :: Bool frontpanel :: Bool idleGCDelayTime :: Time doIdleGC :: Bool heapBase :: Word address to ask the OS for memory allocLimitGrace :: Word

Instances

Show GCFlags |

data ConcFlags Source

Constructors

ConcFlags |
Fields ctxtSwitchTime :: Time ctxtSwitchTicks :: Int

Instances

Show ConcFlags |

data MiscFlags Source

Constructors

MiscFlags |
Fields tickInterval :: Time installSignalHandlers :: Bool machineReadable :: Bool linkerMemBase :: Word address to ask the OS for memory for the linker, 0 ==> off

Instances

Show MiscFlags |

data DebugFlags Source

Flags to control debugging output & extra checking in various subsystems.

Constructors

DebugFlags |
Fields scheduler :: Bool `s` interpreter :: Bool `i` weak :: Bool `w` gccafs :: Bool `G` gc :: Bool `g` block_alloc :: Bool `b` sanity :: Bool `S` stable :: Bool `t` prof :: Bool `p` linker :: Bool `l` the object linker apply :: Bool `a` stm :: Bool `m` squeeze :: Bool `z` stack squeezing & lazy blackholing hpc :: Bool `c` coverage sparks :: Bool `r`

Instances

Show DebugFlags |

data CCFlags Source

Constructors

CCFlags |
Fields doCostCentres :: DoCostCentres profilerTicks :: Int msecsPerTick :: Int

Instances

Show CCFlags |

data ProfFlags Source

Constructors

ProfFlags |
Fields doHeapProfile :: DoHeapProfile heapProfileInterval :: Time time between samples heapProfileIntervalTicks :: Word ticks between samples (derived) includeTSOs :: Bool showCCSOnException :: Bool maxRetainerSetSize :: Word ccsLength :: Word modSelector :: Maybe String descrSelector :: Maybe String typeSelector :: Maybe String ccSelector :: Maybe String ccsSelector :: Maybe String retainerSelector :: Maybe String bioSelector :: Maybe String

Instances

Show ProfFlags |

data TraceFlags Source

Constructors

TraceFlags |
Fields tracing :: DoTrace timestamp :: Bool show timestamp in stderr output traceScheduler :: Bool trace scheduler events traceGc :: Bool trace GC events sparksSampled :: Bool trace spark events by a sampled method sparksFull :: Bool trace spark events 100% accurately user :: Bool trace user events (emitted from Haskell code)

Instances

Show TraceFlags |

data TickyFlags Source

Constructors

TickyFlags |
Fields showTickyStats :: Bool tickyFile :: Maybe FilePath

Instances

Show TickyFlags |

getRTSFlags :: IO RTSFlags Source

getGCFlags :: IO GCFlags Source

getConcFlags :: IO ConcFlags Source

getMiscFlags :: IO MiscFlags Source

getDebugFlags :: IO DebugFlags Source

getCCFlags :: IO CCFlags Source

getProfFlags :: IO ProfFlags Source

getTraceFlags :: IO TraceFlags Source

getTickyFlags :: IO TickyFlags Source